*** Import Stata data ***;

*** OPTIONS ***;
options spool mlogic mprint symbolgen fullstimer msglevel=i ps=200 ls=200 nocenter obs=max;

libname dot ".";

libname interwrk "../sastemp";

%put SASUSER path=%sysfunc(pathname(sasuser));

proc import out=master_sample datafile="../dta/master_sample.dta";
run;
proc import out=researne datafile="../dta/researne.dta";
run;

data interwrk.master_dta;
   merge master_sample(in=a) researne(in=b drop=male);
      by personid;

   length _merge 3;

   _merge=a+2*b;
run;

proc contents data=interwrk.master_dta;
proc freq data=interwrk.master_dta;
   tables _merge male YOB YOD;
run;
proc means data=interwrk.master_dta;
run;
proc print data=interwrk.master_dta(obs=100);
run;
