*** Collect all of the bin files into a new master ***;

*** OPTIONS ***;
options spool mlogic mprint symbolgen fullstimer msglevel=i ps=200 ls=200 nocenter obs=max;

libname dot ".";

libname interwrk "../sastemp";

%put SASUSER path=%sysfunc(pathname(sasuser));

%let ybeg=1998;
%let yend=2019;

*** Macros ***;

%macro dline1;
   data temp1(keep=personid 
   %do yr = &ybeg %to &yend;
      dum&yr
   %end;
   );
%mend;

%macro dcreate;
   %do yr = &ybeg %to &yend;
      dum&yr=labor&yr=0;
   %end;
%mend;

%macro duse;
   %do yr = &ybeg %to &yend;
      if dum&yr=1 and labor&yr=. then labor&yr=0;
   %end;
%mend;

%macro dline2;
   data temp2(keep=personid 
   %do yr = &ybeg %to &yend;
      labor&yr 
   %end;
   );
%mend;

*** Begin Code ***;

%dline1;
   set interwrk.labor;
   %dcreate;
run;

%dline2;
   merge interwrk.labor_bin temp1;
      by personid;
   %duse;
run;

proc contents data=temp2;
proc means data=temp2;
run;

*** Merge the Files Together ***;

data interwrk.master_dta_bin;
   merge interwrk.master_dta(keep=personid male yob yod educ)
         temp2
         interwrk.logearn_bin
         interwrk.logearnc_bin
         interwrk.permearn_bin
         interwrk.permearnalt_bin
         interwrk.researn_bin
         interwrk.researnc_bin
         interwrk.researn1F_bin
         interwrk.researn5F_bin
         interwrk.arcearn1F_bin
         interwrk.arcearn5F_bin
         ;
      by personid;
run;

proc contents data=interwrk.master_dta_bin;
proc means data=interwrk.master_dta_bin;
proc print data=interwrk.master_dta_bin(obs=100);
run;

data interwrk.master_dta_researne_bin;
   merge interwrk.master_dta(keep=personid male) interwrk.researne_bin;
      by personid;
run;

proc contents data=interwrk.master_dta_researne_bin;
proc means data=interwrk.master_dta_researne_bin;
proc print data=interwrk.master_dta_researne_bin(obs=100);
run;
