*** Get Median Earnings for Each Sample ****;
*** All eligible ***;
*** Above Minimum Income ***;
*** 1 yr Above min in t and 1/3min in t+1 ***;
*** 5 yr Above min in t and 1/3min in t+5 ***;
*** 10 yr Permearnalt in t and t+10 ***;

*** OPTIONS ***;
options spool mlogic mprint symbolgen fullstimer msglevel=i ps=200 ls=200 nocenter obs=max;

libname dot ".";

libname interwrk "../sastemp";

%put SASUSER path=%sysfunc(pathname(sasuser));

proc print data=interwrk.master_dta(obs=1000);
run;

data labor(keep=personid year male age labor)
     logearn(keep=personid year male age labor)
     researn1F(keep=personid year male age labor)
     researn5F(keep=personid year male age labor)
     Hresearn1F(keep=personid year male age labor)
     Hresearn5F(keep=personid year male age labor)
     pa5(keep=personid year age male labor)
     pa10(keep=personid year age male labor);
   set interwrk.master_dta_bin(obs=max);

   array lb{1998:2019} labor1998-labor2019; 
   array le{1998:2019} logearn1998-logearn2019;
   array r1{1998:2018} researn1F1998-researn1F2018;
   array r5{1998:2014} researn5F1998-researn5F2014;
   array pe{2000:2019} permearn2000-permearn2019;
   array pa{2000:2019} permearnalt2000-permearnalt2019;

   *** Base labor ***;
   do i=1998 to 2019;
      if lb{i}>0 then do;
         year=i;
         age=year-yob+1;
         labor=lb{i};
         output labor;
      end;
   end;

   *** CS logearn ***;
   do i=1998 to 2019;
      if le{i}~=. then do;
         year=i;
         age=year-yob+1;
         labor=lb{i};
         output logearn;
      end;
   end;

   *** LX_1 researn1F ***;
   do i=1998 to 2018;
      if r1{i}~=. then do;
         year=i;
         age=year-yob+1;
         labor=lb{i};
         output researn1F;
      end;
   end;

   *** LX_5 researn5F ***;
   do i=1998 to 2014;
      if r5{i}~=. then do;
         year=i;
         age=year-yob+1;
         labor=lb{i};
         output researn5F;
      end;
   end;

   *** H_1 researn1F ***;
   do i=2001 to 2018;
      if r1{i}~=. and pe{i-1}~=. then do;
         year=i;
         age=year-yob+1;
         labor=lb{i};
         output Hresearn1F;
      end;
   end;

   *** H_5 researn5F ***;
   do i=2001 to 2014;
      if r5{i}~=. and pe{i-1}~=. then do;
         year=i;
         age=year-yob+1;
         labor=lb{i};
         output Hresearn5F;
      end;
   end;

   *** PA_T5 pa5 ***;
   do i=2000 to 2014;
      if pa{i}~=. and pa{i+5}~=. then do;
         year=i;
         age=year-yob+1;
         labor=lb{i};
         output pa5;
      end;
   end;

   *** PA_T10 pa10 ***;
   do i=2000 to 2009;
      if pa{i}~=. and pa{i+10}~=. then do;
         year=i;
         age=year-yob+1;
         labor=lb{i};
         output pa10;
      end;
   end;
run;

proc contents data=labor;
proc print data=labor(obs=25);
proc summary data=labor nway;
  class year;
  output out=lbs(drop=_TYPE_ _FREQ_) n(labor)=lb_N mean(male)=lb_MN_male mean(age)=lb_MN_age median(labor)=lb_MD_earn;
run;
proc print data=lbs;
run;

proc contents data=logearn;
proc print data=logearn(obs=25);
proc summary data=logearn nway;
  class year;
  output out=les(drop=_TYPE_ _FREQ_) n(labor)=le_N mean(male)=le_MN_male mean(age)=le_MN_age median(labor)=le_MD_earn;
run;
proc print data=les;
run;

proc contents data=researn1F;
proc print data=researn1F(obs=25);
proc summary data=researn1F nway;
  class year;
  output out=r1s(drop=_TYPE_ _FREQ_) n(labor)=r1_N mean(male)=r1_MN_male mean(age)=r1_MN_age median(labor)=r1_MD_earn;
run;
proc print data=r1s;
run;

proc contents data=researn5F;
proc print data=researn5F(obs=25);
proc summary data=researn5F nway;
  class year;
  output out=r5s(drop=_TYPE_ _FREQ_) n(labor)=r5_N mean(male)=r5_MN_male mean(age)=r5_MN_age median(labor)=r5_MD_earn;
run;
proc print data=r5s;
run;

proc contents data=Hresearn1F;
proc print data=Hresearn1F(obs=25);
proc summary data=Hresearn1F nway;
  class year;
  output out=hr1s(drop=_TYPE_ _FREQ_) n(labor)=hr1_N mean(male)=hr1_MN_male mean(age)=hr1_MN_age median(labor)=hr1_MD_earn;
run;
proc print data=hr1s;
run;

proc contents data=Hresearn5F;
proc print data=Hresearn5F(obs=25);
proc summary data=Hresearn5F nway;
  class year;
  output out=hr5s(drop=_TYPE_ _FREQ_) n(labor)=hr5_N mean(male)=hr5_MN_male mean(age)=hr5_MN_age median(labor)=hr5_MD_earn;
run;
proc print data=hr5s;
run;

proc contents data=pa5;
proc print data=pa5(obs=25);
proc summary data=pa5 nway;
  class year;
  output out=pa5s(drop=_TYPE_ _FREQ_) n(labor)=pa5_N mean(male)=pa5_MN_male mean(age)=pa5_MN_age median(labor)=pa5_MD_earn;
run;
proc print data=pa5s;
run;

proc contents data=pa10;
proc print data=pa10(obs=25);
proc summary data=pa10 nway;
  class year;
  output out=pa10s(drop=_TYPE_ _FREQ_) n(labor)=pa10_N mean(male)=pa10_MN_male mean(age)=pa10_MN_age median(labor)=pa10_MD_earn;
run;
proc print data=pa10s;
run;

data dot.sumstats;
   merge lbs les r1s r5s hr1s hr5s pa5s pa10s;
      by year;
run;

proc contents data=dot.sumstats;
proc print data=dot.sumstats;
run;
