*** Round All Statistics to Four Significant Digits ***;

options spool mlogic mprint symbolgen fullstimer msglevel=i ps=200 ls=200 nocenter obs=max;

libname dot ".";

%let sigfig=4;

%macro drb;
   data dlist1(drop=i vlist);
      set &fname;
   
      array numv{*} _NUMERIC_;
   
      /* en.wikipedia.org/wiki/Significant_figures */;
   
      /* Formula
         x = input variable
         p = number of significant digits to retain for input variable x
         v = output variable
         n = floor(log10(x))+1-p
         v = round(x*10**-n)*10**n
      */;
   
      array parm{3} _TEMPORARY_;
   
      do i=1 to dim(numv);
         vlist=numv{i};
   
         if vlist=. or vlist=0 then parm{1}=0;
         else if vlist>0 then parm{1}=1;
         else if vlist<0 then parm{1}=2;
   
         if parm{1}=1 then do;
            parm{3}=vlist;
            parm{2}=floor(log10(parm{3}))+1-&sigfig;
            vlist=(round(parm{3}*10**-parm{2})*10**parm{2});
         end;
         else if parm{1}=2 then do;
            parm{3}=abs(vlist);
            parm{2}=floor(log10(parm{3}))+1-&sigfig;
            vlist=-(round(parm{3}*10**-parm{2})*10**parm{2});
         end;
         numv{i}=vlist;
      end;
   run;
   
   title1 "################################################################################ ";
   title2 "### Sample [&samp.] # Variable [&var.] # Program [&prog.] # Result File [&fname.] ###"; 
   proc print data=dlist1;
   run;
%mend;


*** Disclosure List 1 ****;
/* Sample:      */; %let samp  = all;
/* Variable:    */; %let var   = various;
/* Program:     */; %let prog  = 01.04.samples_earn.sas;
/* Result File: */; %let fname = dot.sumstats;
%drb;
