*** Get the data from the EHF ***;

%include "config.sas";

proc options option=(memsize sumsize sortsize) define;
run;


proc summary data=ui.ehf_interleave(where=(year>=&begyr and year<=&endyr)) nway;
   class pik year sein;
   output out=earnlist(drop=_TYPE_ _FREQ_) sum(earn)=earn_job;
run;

proc contents data=earnlist;
proc print data=earnlist(obs=50);
run;

data outputs.uipikyear(keep=pik year earn_ann njobs earn_max dom_sein dom_state)
     outputs.uipik(keep=pik);
   set earnlist;
      by pik year;

   retain earn_ann njobs earn_max dom_sein;
   length njobs 4 dom_state $2 dom_sein $12;

   if first.year then do;
      earn_ann=0;
      njobs=0;
      earn_max=earn_job;
      dom_sein=sein;
   end;

   earn_ann=earn_ann+earn_job;
   njobs=njobs+1;
   if earn_job>earn_max then do;
      earn_max=earn_job;
      dom_sein=sein;
   end;

   if last.year then do;
      stfp=input(substr(sein,1,2),2.);
      dom_state=fipstate(stfp);
      output outputs.uipikyear;
   end;

   if last.pik then output outputs.uipik;
run;

proc contents data=outputs.uipikyear;
proc means data=outputs.uipikyear n min max;
   class dom_state /missing;
   var year;
run;
proc freq data=outputs.uipikyear;
   tables year*dom_state /out=tab1 noprint;
run;
proc means data=tab1 n sum min max;
   class year;
   var count;
run;
proc tabulate data=outputs.uipikyear;
   class year njobs /missing;
   table year all, n*f=comma14.0 pctn;
   table njobs all, n*f=comma14.0 pctn;
run;
proc means data=outputs.uipikyear;
   class year;
   var earn_ann njobs earn_max;
run;
proc print data=outputs.uipikyear(obs=1000);
run;

proc contents data=outputs.uipik;
proc print data=outputs.uipik(obs=10);
run;
