*** Get the required information from the ICF and the Numident ***;

%include "config.sas";

proc options option=(memsize sumsize sortsize) define;
run;


*** Get Numident Date of Death ***;

/* Date of Death */;
data dod(keep=pik dob dob_flag dob_year dob_month dob_day
         rename=(dob=DOD
                 dob_flag=DOD_flag
                 dob_year=DOD_year
                 dob_month=DOD_month
                 dob_day=DOD_day));
   set cnum.cnum_current(keep=pik dodcc dodyy dodmm doddd
                      rename=(dodcc=dobcc
                              dodyy=dobyy
                              dodmm=dobmm
                              doddd=dobdd));

   %include "00.02_dob_final.txt";
run;

proc contents data=dod;
proc tabulate data=dod;
   class dod_year dod_flag /missing;
   table dod_year all, n*f=comma14.0 pctn;
   table dod_flag all, n*f=comma14.0 pctn;
run;
proc print data=dod(obs=100);
run;

data outputs.uipik_icf_cnum(keep=pik personid _merge cnum male YOB YOD educ);
   retain personid (0) _merge cnum pik male YOB YOD educ;

   merge outputs.uipik(in=a)
         ui.icf_us(in=b keep=pik DOB sex educ_c)
         dod(keep=pik DOD_year rename=(DOD_year=YOD) in=c);
      by pik;

   length personid 6 _merge $3 cnum 3 male YOB educ 3;

   _merge=put(a,1.) || put(b,1.) || put(c,1.);

   personid=personid+1;

   cnum=c;

   if b=1 then do;
      if sex="M" then male=1;
      else if sex="F" then male=0;
      
      YOB=year(DOB);

      educ=input(educ_c,1.);
   end;

   if a=1 then output;
run;

proc contents data=outputs.uipik_icf_cnum;
proc means data=outputs.uipik_icf_cnum;
   var personid;
run;
proc tabulate data=outputs.uipik_icf_cnum;
   class _merge cnum male YOB YOD educ /missing;
   table _merge all, n*f=comma14.0 pctn;
   table cnum all, n*f=comma14.0 pctn;
   table male all, n*f=comma14.0 pctn;
   table YOB all, n*f=comma14.0 pctn;
   table YOD all, n*f=comma14.0 pctn;
   table educ all, n*f=comma14.0 pctn;
run;
proc print data=outputs.uipik_icf_cnum(obs=100);
run;
