/*-----------------------------------------------------*/
/* Original Author: Lars Vilhuber                      */
/* Time-stamp: <02/23/2013 15:24 abowd001 >            */
/* Last modified: Kevin McKinney 20180926              */
/*-----------------------------------------------------*/
%let thisfile=macro_pce.sas ;
%let fullpath=%sysget(PWD)/&thisfile.;
%let pce_startyr=1980;
%let pce_endyr=2017;

%put MMM::: ;
%put MMM::: ;
%put MMM::: &fullpath;
%put MMM::: ;
%put MMM::: Provides macro variables pceYYYY;
%put MMM::: which contain the PCE (100=1980-2017);
%put MMM:::       YYYY=&pce_startyr.-&pce_endyr.;
%put MMM::: Provides macro xpce;
%put MMM::: which initializes a SAS array xpce(&pce_startyr.:&pce_endyr.;
%put MMM::: when called.;
%put MMM::: ;
%put MMM::: Source: Robert Moffit;
%put MMM::: ;
%put MMM::: This series is current until 2017;

/* NOTE: when updating this file, please add in these lines, if necessary: */
  %put MMM::: ; 


/* these are yearly averages of the PCE */

%let pce1980=43.11373491;
%let pce1981=46.97560211;
%let pce1982=49.58570608;
%let pce1983=51.69426885;
%let pce1984=53.64714487;
%let pce1985=55.51852045;
%let pce1986=56.72639883;
%let pce1987=58.47552374;
%let pce1988=60.76067081;
%let pce1989=63.41361475;
%let pce1990=66.19821326;
%let pce1991=68.41126378;
%let pce1992=70.234575;
%let pce1993=71.98369991;
%let pce1994=73.48623374;
%let pce1995=75.0336973;
%let pce1996=76.63758424;
%let pce1997=77.9718928;
%let pce1998=78.59150515;
%let pce1999=79.76385769;
%let pce2000=81.74599028;
%let pce2001=83.31644115;
%let pce2002=84.41460739;
%let pce2003=86.05402017;
%let pce2004=88.19915365;
%let pce2005=90.7079045;
%let pce2006=93.17590513;
%let pce2007=95.54150776;
%let pce2008=98.40656183;
%let pce2009=98.31670237;
%let pce2010=100;
%let pce2011=102.5348728;
%let pce2012=104.4877488;
%let pce2013=105.8941539;
%let pce2014=107.4844574;
%let pce2015=107.7540358;
%let pce2016=108.912805;
%let pce2017=110.8332898;

%macro xpce;
    array xpce(&pce_startyr.:&pce_endyr.) pce&pce_startyr.-pce&pce_endyr.;
    retain pce&pce_startyr.-pce&pce_endyr.;
    drop pce&pce_startyr.-pce&pce_endyr.;
    if _n_=1 then do;
    %local i;
    %do i=&pce_startyr. %to &pce_endyr.;
	pce&i. = &&pce&i ;
	%end;
    end;
    %put +++ PCEARRAY:::;
    %put +++ PCEARRAY::: Array xpce(&pce_startyr.-&pce_endyr.) initialized ;
    %put +++ PCEARRAY::: Variables will be dropped ;
    %put +++ PCEARRAY:::;
%mend;
