*** Get active UI quarters for each state ***;

%include "../config.sas";
%include "../00_macros/pik2short.sas";
%include "../00_macros/pik2full.sas";
%include "../00_macros/dline.sas";
%include "../00_macros/oline.sas";


*** Create Eligible Worker Series ***;

data eligible(drop=first_year last_year) firstlast(keep=pik first_year last_year);
   set outputs.cnum_strip2(in=b keep=pik gender gender_flag POB POB_flag DOB DOD DOC);

   length year born_US age first_year last_year 3;

   uni=rand('UNIFORM');
   if gender_flag=9 then do;
      if uni<=0.5 then gender="F";
      else gender="M";
      gender_flag=1;
   end;

   if POB_flag=9 then do;
      POB="A";
      POB_flag=1;
   end;

   born_US=POB="A";

   if DOC~=. then DOC_year=year(DOC);

   first_year=0;

   do year=2004 to 2015;

      date1=mdy(1,1,year);
      date2=mdy(12,31,year);

      age=year-year(DOB);
      if month(DOB)>6 then age=age-1;

      if born_US=0 and DOC_year>. then years_us=(year-DOC_year);

      if (age>=25 and age<=65) and (DOD=. or DOD>date2) and (years_us=. or years_us>=0) then do;
         if first_year=0 then first_year=year;
         last_year=year;
         output eligible;
      end;
   end;
   output firstlast;
run;

proc contents data=eligible;
proc freq data=eligible;
   tables gender_flag POB_flag /list missing;
run;
proc means data=eligible;
proc print data=eligible(obs=1000);
run;

%dline(lib=outputs,data=eligible,keepvars=_ALL_,compress=no);
   merge eligible(in=a keep=pik year gender born_US age) firstlast;
      by pik;

   drop pik2digit;
   rename gender=sex;

   length pik2digit $2;

   pik2digit=substr(pik,1,2);

   if a=1 then do;
      %oline(lib=outputs,data=eligible);
   end;
run;

proc contents data=outputs.eligible_00;
proc means data=outputs.eligible_00;
proc print data=outputs.eligible_00(obs=1000);
run;
