*** Get HC Estimates ***;

%include "../config.sas";

* Hours Imputation *;
libname hc "";

libname dot ".";


data temp1 /view=temp1;
   set hc.hours_impute(keep=pik year firmid hours_ann_p where=(year>=2004 and year<=2015));
run;

data temp2(keep=pik hours num_jobs) /view=temp2;
   set temp1;
      by pik firmid;

   length hours num_jobs 3;

   retain hours_all num_jobs;

   if first.pik then do;
      hours_all=0;
      num_jobs=0;
   end;

   if first.firmid then num_jobs=num_jobs+1;

   hours_all=hours_all+hours_ann_p;

   if last.pik then do;
      hours=round(hours_all/12);
      if hours>&cut_hrs then hours=&cut_hrs;
      if num_jobs>&cut_jbs then num_jobs=&cut_jbs;
      output;
   end;
run;  

proc contents data=temp2;
proc print data=temp2(obs=100);
run;

data outputs.hours(keep=pik hours num_jobs);
   merge outputs.pik_vars(keep=pik in=a) temp2(in=b);
      by pik;

   if a=1 then output;
run;

proc contents data=outputs.hours;
proc means data=outputs.hours;
   var hours num_jobs;
run;
proc print data=outputs.hours(obs=100);
run;
