*** Diffs In Chars By Demo Groups ***;

%include "../config.sas";



options nolabel;

*** Earn and LFA ***;

proc means data=outputs.pik_vars_2 mean min p10 p25 median p75 p90 max;
   class pchar;
   var earn_all ea1 ea2 ea3 log_earn_all full partial inactive ftspells ediff_m ediff_v hours num_jobs;
run;

*** Age and Education ***;

proc means data=outputs.pik_vars_2 mean min p10 p25 median p75 p90 max;
   class pchar;
   var first_age;
run;

proc tabulate data=outputs.pik_vars_2;
   class pchar educ_c /missing;
   table pchar*(educ_c all='Subtotal') all='Total'
         , n*f=comma14.0 pctn<educ_c all> pctn;
run;

proc tabulate data=outputs.pik_vars_2(where=(educ_r~=" "));
   class pchar educ_r /missing;
   table pchar*(educ_r all='Subtotal') all='Total'
         , n*f=comma14.0 pctn<educ_r all> pctn;
run;

*** Firm Chars (State and Industry Not Included) ***;

data temp1(keep=pchar region) /view=temp1;
   set outputs.pik_vars_2;

   if st_dom in ("CT", "ME", "MA", "NH", "RI", "VT") then region=1;
   else if st_dom in ("NJ", "NY", "PA") then region=2;
   else if st_dom in ("IL", "IN","MI", "OH", "WI") then region=3;
   else if st_dom in ("IA", "KS", "MN", "MO", "NE", "ND", "SD") then region=4;
   else if st_dom in ("DE", "FL", "GA", "MD", "NC", "SC", "VA", "DC", "WV") then region=5;
   else if st_dom in ("AL", "KY", "MS", "TN") then region=6;
   else if st_dom in ("AR", "LA", "OK", "TX") then region=7;
   else if st_dom in ("AZ", "CO", "ID", "MT", "NV", "NM", "UT", "WY") then region=8;
   else if st_dom in ("AK", "CA", "HI", "OR", "WA") then region=9;
run;

proc tabulate data=temp1;
   class pchar region /missing;
   table pchar*(region all='Subtotal') all='Total'
         , n*f=comma14.0 pctn<region all> pctn;
run;

proc tabulate data=outputs.pik_vars_2;
   class pchar ind_dom /missing;
   table pchar*(ind_dom all='Subtotal') all='Total'
         , n*f=comma14.0 pctn<ind_dom all> pctn;
run;

proc means data=outputs.pik_vars_2 mean min p10 p25 median p75 p90 max;
   class pchar;
   var ces_age ui_age ces_size ui_size;
run;

*** Skill ***;

proc means data=outputs.pik_vars_2 mean min p10 p25 median p75 p90 max;
   class pchar;
   var nr_cog_anal nr_cog_pers nr_man_pers nr_man_phys r_cog r_man offshor;
run;

*** HC Estimates ***;

proc means data=outputs.pik_vars_2 mean min p10 p25 median p75 p90 max;
   class pchar;
   var theta psi_pik;
run;
