*** Round All Statistics to Four Significant Digits ***;

%include "../config.sas";

options ps=32767;

%let sigfig=4;

%macro drb;
   data dlist1(drop=i vlist);
      set &fname;

      array numv{*} _NUMERIC_;

      /* en.wikipedia.org/wiki/Significant_figures */;

      /* Formula
         x = input variable
         p = number of significant digits to retain for input variable x
         v = output variable
         n = floor(log10(x))+1-p
         v = round(x*10**-n)*10**n
      */;

      array parm{3} _TEMPORARY_;

      do i=1 to dim(numv);
         vlist=numv{i};

         if vlist=. or vlist=0 then parm{1}=0;
         else if vlist>0 then parm{1}=1;
         else if vlist<0 then parm{1}=2;

         if parm{1}=1 then do;
            parm{3}=vlist;
            parm{2}=floor(log10(parm{3}))+1-&sigfig;
            vlist=(round(parm{3}*10**-parm{2})*10**parm{2});
         end;
         else if parm{1}=2 then do;
            parm{3}=abs(vlist);
            parm{2}=floor(log10(parm{3}))+1-&sigfig;
            vlist=-(round(parm{3}*10**-parm{2})*10**parm{2});
         end;
         numv{i}=vlist;
      end;
   run;

   title1 "################################################################################ ";
   title2 "### Listing [&list.] Sample [&samp.] # Variable [&var.] # Program [&prog.] # Result File [&fname.] ###";
   proc print data=dlist1;
   run;
%mend;


*** Disclosure List 1 ****;
/* List:        */; %let list  = 1;
/* Sample:      */; %let samp  = 1 : Persons : Earnings Regressions;
/* Variable:    */; %let var   = Parameter Estimates;
/* Program:     */; %let prog  = 02.01.reg_glm.sas;
/* Result File: */; %let fname = dot.glm_betas_02;
%drb;
