#!/bin/bash

if [ -z $1 ]
then
   echo "Directory Name Required"
   exit
else
   dname=$1
fi

if [ -d $dname ]
then
   echo "Directory Exists"
   exit
else
   mkdir $dname
fi

cp skel/01_qrdecomp.sas ${dname}/01_qrdecomp.sas
cp skel/02_make_qdat_all.sas ${dname}/02_make_qdat_all.sas

pc=("0FAN" "0FBN" "0FOA" "0FWH" "0FWN" "0MAN" "0MBN" "0MOA" "0MWH" "0MWN" "1FAN" "1FBN" "1FOA" "1FWH" "1FWN" "1MAN" "1MBN" "1MOA" "1MWH" "1MWN")

sz=(2500000 800000 540000 3300000 2000000 2500000 800000 620000 4000000 2200000 330000 6400000 1400000 2700000 35000000 360000 5800000 1300000 2600000 36000000)

printf -v int %0.f "$float"

for i in ${!pc[@]}
do
  tag=${pc[$i]}
  float=$(echo 5 \+ ${sz[$i]} \* 0.000004 | bc -l)
  tsz=${float%.*}
  echo $tag
  echo $tsz
  mkdir ${dname}/${tag}
  cp skel/launch_pbs.bash ${dname}/${tag}/launch_pbs.bash
  cat ${dname}/${tag}/launch_pbs.bash | sed s/mm=X/mm=${tsz}/ > xyz
  cat xyz | sed s/rg=XXXX/rg=${tag}/ > ${dname}/${tag}/launch_${tag}.bash
  rm -f xyz
  rm -f ${dname}/${tag}/launch_pbs.bash
done
