*** Create all variables for our decomposition ***;

%include "../../../config.sas";

%let rnum=%sysget(rnum);

%macro loop(rt,pa,pb);

%let mb=hours hours2 hours3 hours4 partial inactive 
region_1 region_2 region_3 region_4 region_5 region_6 region_7 region_8 region_9 
ind_dom_A ind_dom_B ind_dom_C ind_dom_D ind_dom_E ind_dom_F ind_dom_G ind_dom_H ind_dom_I ind_dom_J
ind_dom_K ind_dom_L ind_dom_M ind_dom_N ind_dom_O ind_dom_P ind_dom_Q ind_dom_R ind_dom_S ind_dom_T
first_age
educ_c_1 educ_c_2 educ_c_3 educ_c_4;

proc contents data=outputs.pik_vars_2;
run;

data temp1(keep=pik log_earn_all &mb udrawa udrawb);
   set outputs.pik_vars_2(obs=max keep=pik pchar log_earn_all hours full partial inactive st_dom ind_dom first_age educ_c rename=(hours=hours_temp) where=(pchar="&pa"));

   hours=(hours_temp*12)/(full+partial);
   hours2=(hours**2)/1000;
   hours3=(hours**3)/10000000;
   hours4=(hours**4)/10000000000;

   *** region ***;
   length region_1 region_2 region_3 region_4 region_5 region_6 region_7 region_8 region_9 3;

   region_1=0; region_2=0; region_3=0; region_4=0; region_5=0; region_6=0; region_7=0; region_8=0; region_9=0; 
   if st_dom in ("CT", "ME", "MA", "NH", "RI", "VT") then region_1=1;
   else if st_dom in ("NJ", "NY", "PA") then region_2=1;
   else if st_dom in ("IL", "IN","MI", "OH", "WI") then region_3=1;
   else if st_dom in ("IA", "KS", "MN", "MO", "NE", "ND", "SD") then region_4=1;
   else if st_dom in ("DE", "FL", "GA", "MD", "NC", "SC", "VA", "DC", "WV") then region_5=1;
   else if st_dom in ("AL", "KY", "MS", "TN") then region_6=1;
   else if st_dom in ("AR", "LA", "OK", "TX") then region_7=1;
   else if st_dom in ("AZ", "CO", "ID", "MT", "NV", "NM", "UT", "WY") then region_8=1;
   else if st_dom in ("AK", "CA", "HI", "OR", "WA") then region_9=1;

   *** industry ***;
   length ind_dom_A ind_dom_B ind_dom_C ind_dom_D ind_dom_E ind_dom_F ind_dom_G ind_dom_H ind_dom_I ind_dom_J 3;
   length ind_dom_K ind_dom_L ind_dom_M ind_dom_N ind_dom_O ind_dom_P ind_dom_Q ind_dom_R ind_dom_S ind_dom_T 3;

   ind_dom_A=0; ind_dom_B=0; ind_dom_C=0; ind_dom_D=0; ind_dom_E=0; ind_dom_F=0; ind_dom_G=0; ind_dom_H=0; ind_dom_I=0; ind_dom_J=0;
   ind_dom_K=0; ind_dom_L=0; ind_dom_M=0; ind_dom_N=0; ind_dom_O=0; ind_dom_P=0; ind_dom_Q=0; ind_dom_R=0; ind_dom_S=0; ind_dom_T=0;
   
   if ind_dom="A" then ind_dom_A=1;
   else if ind_dom="B" then ind_dom_B=1;
   else if ind_dom="C" then ind_dom_C=1;
   else if ind_dom="D" then ind_dom_D=1;
   else if ind_dom="E" then ind_dom_E=1;
   else if ind_dom="F" then ind_dom_F=1;
   else if ind_dom="G" then ind_dom_G=1;
   else if ind_dom="H" then ind_dom_H=1;
   else if ind_dom="I" then ind_dom_I=1;
   else if ind_dom="J" then ind_dom_J=1;
   else if ind_dom="K" then ind_dom_K=1;
   else if ind_dom="L" then ind_dom_L=1;
   else if ind_dom="M" then ind_dom_M=1;
   else if ind_dom="N" then ind_dom_N=1;
   else if ind_dom="O" then ind_dom_O=1;
   else if ind_dom="P" then ind_dom_P=1;
   else if ind_dom="Q" then ind_dom_Q=1;
   else if ind_dom="R" then ind_dom_R=1;
   else if ind_dom="S" then ind_dom_S=1;
   else if ind_dom="T" then ind_dom_T=1;

   *** education ***;
   length educ_c_1 educ_c_2 educ_c_3 educ_c_4 3;

   educ_c_1=0; educ_c_2=0; educ_c_3=0; educ_c_4=0;

   if educ_c="1" then educ_c_1=1;
   else if educ_c="2" then educ_c_2=1;
   else if educ_c="3" then educ_c_3=1;
   else if educ_c="4" then educ_c_4=1;

   udrawa=rand('UNIFORM');
   udrawb=rand('UNIFORM');
run;

proc contents data=temp1;
proc print data=temp1(obs=100);
run;

*** Bin the random draw ***;

proc hpbin data=temp1 out=temp2 numbin=99 bucket;
   id pik log_earn_all &mb;
   input udrawa udrawb;
   performance details threads=6;
run;

proc contents data=temp2;
proc print data=temp2(obs=100);
run;
*** Get the coefficients ***;

data qparm1(drop=pchar Quantile);
      set dot.qparms_all(where=(pchar="&pa"));

   rename Intercept = ba0;
   rename hours     = ba1;
   rename hours2    = ba2;
   rename hours3    = ba3;
   rename hours4    = ba4;
   rename partial   = ba5;
   rename inactive  = ba6;
   rename region_1  = ba7;
   rename region_2  = ba8;
   rename region_3  = ba9;
   rename region_4  = ba10;
   rename region_5  = ba11;
   rename region_6  = ba12;
   rename region_7  = ba13;
   rename region_8  = ba14;
   rename region_9  = ba15;
   rename ind_dom_A = ba16;
   rename ind_dom_B = ba17;
   rename ind_dom_C = ba18;
   rename ind_dom_D = ba19;
   rename ind_dom_E = ba20;
   rename ind_dom_F = ba21;
   rename ind_dom_G = ba22;
   rename ind_dom_H = ba23;
   rename ind_dom_I = ba24;
   rename ind_dom_J = ba25;
   rename ind_dom_K = ba26;
   rename ind_dom_L = ba27;
   rename ind_dom_M = ba28;
   rename ind_dom_N = ba29;
   rename ind_dom_O = ba30;
   rename ind_dom_P = ba31;
   rename ind_dom_Q = ba32;
   rename ind_dom_R = ba33;
   rename ind_dom_S = ba34;
   rename ind_dom_T = ba35;
   rename first_age = ba36;
   rename educ_c_1  = ba37;
   rename educ_c_2  = ba38;
   rename educ_c_3  = ba39;
   rename educ_c_4  = ba40;
run;

data qparm0(drop=pchar Quantile);
      set dot.qparms_all(where=(pchar="&pb"));

   rename Intercept = bb0;
   rename hours     = bb1;
   rename hours2    = bb2;
   rename hours3    = bb3;
   rename hours4    = bb4;
   rename partial   = bb5;
   rename inactive  = bb6;
   rename region_1  = bb7;
   rename region_2  = bb8;
   rename region_3  = bb9;
   rename region_4  = bb10;
   rename region_5  = bb11;
   rename region_6  = bb12;
   rename region_7  = bb13;
   rename region_8  = bb14;
   rename region_9  = bb15;
   rename ind_dom_A = bb16;
   rename ind_dom_B = bb17;
   rename ind_dom_C = bb18;
   rename ind_dom_D = bb19;
   rename ind_dom_E = bb20;
   rename ind_dom_F = bb21;
   rename ind_dom_G = bb22;
   rename ind_dom_H = bb23;
   rename ind_dom_I = bb24;
   rename ind_dom_J = bb25;
   rename ind_dom_K = bb26;
   rename ind_dom_L = bb27;
   rename ind_dom_M = bb28;
   rename ind_dom_N = bb29;
   rename ind_dom_O = bb30;
   rename ind_dom_P = bb31;
   rename ind_dom_Q = bb32;
   rename ind_dom_R = bb33;
   rename ind_dom_S = bb34;
   rename ind_dom_T = bb35;
   rename first_age = bb36;
   rename educ_c_1  = bb37;
   rename educ_c_2  = bb38;
   rename educ_c_3  = bb39;
   rename educ_c_4  = bb40;
run;

data pgroup(keep=log_earn_all BIN_udrawa BIN_udrawb leap_waxa leap_wbxa pdiffaa pdiffba rename=(log_earn_all=lea));
   set temp2();

   array xa{1:40} &mb;

   array ba{0:40} ba0-ba40;
   array betaa{1:99,0:40} _TEMPORARY_;

   array bb{0:40} bb0-bb40;
   array betab{1:99,0:40} _TEMPORARY_;

   if _N_=1 then do;
      do i=1 to 99;
         set qparm1;
         do j=0 to 40;
            betaa{i,j}=ba{j};
         end;
      end;

      do i=1 to 99;
         set qparm0;
         do j=0 to 40;
            betab{i,j}=bb{j};
         end;
      end;
  end;

   leap_waxa=betaa{BIN_udrawa,0};
   do i=1 to 40;
      leap_waxa=leap_waxa+xa{i}*betaa{BIN_udrawa,i};
   end;

   pdiffaa=leap_waxa-log_earn_all;

   leap_wbxa=betab{BIN_udrawb,0};
   do i=1 to 40;
      leap_wbxa=leap_wbxa+xa{i}*betab{BIN_udrawb,i};
   end;

   pdiffba=leap_wbxa-log_earn_all;
run;

proc summary data=pgroup;
   var lea leap_waxa leap_wbxa;
   output out=pred_ab(drop=_type_ _freq_) p10= p25= p50= p75= p90=/autoname;
run;

%if &rt=1 %then %do;
   data dv_ab;
      retain pchara pcharb;
      set pred_ab;

      length pchara pcharb $4;
         
      pchara="&pa";
      pcharb="&pb";
   run;
%end;
%else %if &rt=2 %then %do;
   data dv_ab;
      retain pchara pcharb;
      set pred_ab;

      length pchara pcharb $4;
         
      pchara="&pb";
      pcharb="&pa";

      rename lea_P10       = leb_P10      ;
      rename lea_P25       = leb_P25      ;
      rename lea_P50       = leb_P50      ;
      rename lea_P75       = leb_P75      ;
      rename lea_P90       = leb_P90      ;
      rename leap_waxa_P10 = leap_wbxb_P10;
      rename leap_waxa_P25 = leap_wbxb_P25;
      rename leap_waxa_P50 = leap_wbxb_P50;
      rename leap_waxa_P75 = leap_wbxb_P75;
      rename leap_waxa_P90 = leap_wbxb_P90;
      rename leap_wbxa_P10 = leap_waxb_P10;
      rename leap_wbxa_P25 = leap_waxb_P25;
      rename leap_wbxa_P50 = leap_waxb_P50;
      rename leap_wbxa_P75 = leap_waxb_P75;
      rename leap_wbxa_P90 = leap_waxb_P90;
   run;
%end;      

proc contents data=dv_ab;
proc print data=dv_ab;
run;

proc append base=dv&rt data=dv_ab;
run;

%mend;


*19 groups (rt=1 : x variables are determined by pchar group a : create waxa and wbxa);

%loop(1,0FAN,1MWN);
%loop(1,0FBN,1MWN);
%loop(1,0FOA,1MWN);
%loop(1,0FWH,1MWN);
%loop(1,0FWN,1MWN);
%loop(1,0MAN,1MWN);
%loop(1,0MBN,1MWN);
%loop(1,0MOA,1MWN);
%loop(1,0MWH,1MWN);
%loop(1,0MWN,1MWN);
%loop(1,1FAN,1MWN);
%loop(1,1FBN,1MWN);
%loop(1,1FOA,1MWN);
%loop(1,1FWH,1MWN);
%loop(1,1FWN,1MWN);
%loop(1,1MAN,1MWN);
%loop(1,1MBN,1MWN);
%loop(1,1MOA,1MWN);
%loop(1,1MWH,1MWN);

*19 groups (rt=2 : x variables are determined by pchar group b : create wbxb and waxb);

%loop(2,1MWN,0FAN);
%loop(2,1MWN,0FBN);
%loop(2,1MWN,0FOA);
%loop(2,1MWN,0FWH);
%loop(2,1MWN,0FWN);
%loop(2,1MWN,0MAN);
%loop(2,1MWN,0MBN);
%loop(2,1MWN,0MOA);
%loop(2,1MWN,0MWH);
%loop(2,1MWN,0MWN);
%loop(2,1MWN,1FAN);
%loop(2,1MWN,1FBN);
%loop(2,1MWN,1FOA);
%loop(2,1MWN,1FWH);
%loop(2,1MWN,1FWN);
%loop(2,1MWN,1MAN);
%loop(2,1MWN,1MBN);
%loop(2,1MWN,1MOA);
%loop(2,1MWN,1MWH);

proc sort data=dv1;
   by pchara pcharb;
run;

proc sort data=dv2;
   by pchara pcharb;
run;

data dot.decompvars&rnum;
   retain 
   pchara  pcharb
   lea_P10 leb_P10 leap_waxa_P10 leap_waxb_P10 leap_wbxa_P10 leap_wbxb_P10
   lea_P25 leb_P25 leap_waxa_P25 leap_waxb_P25 leap_wbxa_P25 leap_wbxb_P25
   lea_P50 leb_P50 leap_waxa_P50 leap_waxb_P50 leap_wbxa_P50 leap_wbxb_P50
   lea_P75 leb_P75 leap_waxa_P75 leap_waxb_P75 leap_wbxa_P75 leap_wbxb_P75
   lea_P90 leb_P90 leap_waxa_P90 leap_waxb_P90 leap_wbxa_P90 leap_wbxb_P90;

   merge dv1 dv2;
      by pchara pcharb;
run;

proc contents data=dot.decompvars&rnum;
proc print data=dot.decompvars&rnum;
run;
