*** Create tables of decomposition and results ***;

%include "../../../config.sas";

data temp1;
   set dot.decompvars:;
run;

proc contents data=temp1 order=varnum;
run;

proc summary data=temp1 nway;
   class pchara pcharb;
   output out=temp2(drop=_TYPE_ _FREQ_) N(_NUMERIC_)= mean(_NUMERIC_)= std(_NUMERIC_)= /autoname;
run;

proc contents data=temp2;
proc means data=temp2;
   class pchara pcharb;
run;
proc print data=temp2;
run;

data temp3;
   set temp2(keep=pchara pcharb
                  lea_P10_Mean      
                  leb_P10_Mean      
                  leap_waxa_P10_Mean
                  leap_waxb_P10_Mean
                  leap_wbxa_P10_Mean
                  leap_wbxb_P10_Mean
                  lea_P25_Mean      
                  leb_P25_Mean      
                  leap_waxa_P25_Mean
                  leap_waxb_P25_Mean
                  leap_wbxa_P25_Mean
                  leap_wbxb_P25_Mean
                  lea_P50_Mean      
                  leb_P50_Mean      
                  leap_waxa_P50_Mean
                  leap_waxb_P50_Mean
                  leap_wbxa_P50_Mean
                  leap_wbxb_P50_Mean
                  lea_P75_Mean      
                  leb_P75_Mean      
                  leap_waxa_P75_Mean
                  leap_waxb_P75_Mean
                  leap_wbxa_P75_Mean
                  leap_wbxb_P75_Mean
                  lea_P90_Mean      
                  leb_P90_Mean      
                  leap_waxa_P90_Mean
                  leap_waxb_P90_Mean
                  leap_wbxa_P90_Mean
                  leap_wbxb_P90_Mean);

   rename lea_P10_Mean      =lea_P10      ;
   rename leb_P10_Mean      =leb_P10      ;
   rename leap_waxa_P10_Mean=leap_waxa_P10;
   rename leap_waxb_P10_Mean=leap_waxb_P10;
   rename leap_wbxa_P10_Mean=leap_wbxa_P10;
   rename leap_wbxb_P10_Mean=leap_wbxb_P10;
   rename lea_P25_Mean      =lea_P25      ;
   rename leb_P25_Mean      =leb_P25      ;
   rename leap_waxa_P25_Mean=leap_waxa_P25;
   rename leap_waxb_P25_Mean=leap_waxb_P25;
   rename leap_wbxa_P25_Mean=leap_wbxa_P25;
   rename leap_wbxb_P25_Mean=leap_wbxb_P25;
   rename lea_P50_Mean      =lea_P50      ;
   rename leb_P50_Mean      =leb_P50      ;
   rename leap_waxa_P50_Mean=leap_waxa_P50;
   rename leap_waxb_P50_Mean=leap_waxb_P50;
   rename leap_wbxa_P50_Mean=leap_wbxa_P50;
   rename leap_wbxb_P50_Mean=leap_wbxb_P50;
   rename lea_P75_Mean      =lea_P75      ;
   rename leb_P75_Mean      =leb_P75      ;
   rename leap_waxa_P75_Mean=leap_waxa_P75;
   rename leap_waxb_P75_Mean=leap_waxb_P75;
   rename leap_wbxa_P75_Mean=leap_wbxa_P75;
   rename leap_wbxb_P75_Mean=leap_wbxb_P75;
   rename lea_P90_Mean      =lea_P90      ;
   rename leb_P90_Mean      =leb_P90      ;
   rename leap_waxa_P90_Mean=leap_waxa_P90;
   rename leap_waxb_P90_Mean=leap_waxb_P90;
   rename leap_wbxa_P90_Mean=leap_wbxa_P90;
   rename leap_wbxb_P90_Mean=leap_wbxb_P90;

run;

proc contents data=temp3;
proc print data=temp3;

data dot.decomprun_avg(drop=lea_P10      lea_P25      lea_P50      lea_P75      lea_P90
                leap_waxa_P10 leap_waxa_P25 leap_waxa_P50 leap_waxa_P75 leap_waxa_P90
                leap_waxb_P10 leap_waxb_P25 leap_waxb_P50 leap_waxb_P75 leap_waxb_P90
                leap_wbxa_P10 leap_wbxa_P25 leap_wbxa_P50 leap_wbxa_P75 leap_wbxa_P90
                leap_wbxb_P10 leap_wbxb_P25 leap_wbxb_P50 leap_wbxb_P75 leap_wbxb_P90
                leb_P10      leb_P25      leb_P50      leb_P75      leb_P90 rename=(pchara=pchar1 pcharb=pchar0));

    set temp3;

    *** p10 ***;
    quantile=0.10;
    actual1=lea_P10;
    actual0=leb_P10;
    actual_diff=lea_P10-leb_P10;

    leap_w1x1=leap_waxa_p10;
    leap_w0x0=leap_wbxb_p10;
    leap_w0x1=leap_wbxa_p10;
    leap_w1x0=leap_waxb_P10;

    pred_diff=leap_w1x1-leap_w0x0;
    resid=pred_diff-actual_diff;
    relerr=resid/actual_diff;

    coeff_diff1=leap_w1x0-leap_w0x0;
    covar_diff1=leap_w1x1-leap_w1x0;
    coeff_diff2=leap_w1x1-leap_w0x1;
    covar_diff2=leap_w0x1-leap_w0x0;

    coeff_share1=coeff_diff1/pred_diff;
    covar_share1=covar_diff1/pred_diff;
    coeff_share2=coeff_diff2/pred_diff;
    covar_share2=covar_diff2/pred_diff;
    output;


    *** p25 ***;
    quantile=0.25;
    actual1=lea_P25;
    actual0=leb_P25;
    actual_diff=lea_P25-leb_P25;

    leap_w1x1=leap_waxa_p25;
    leap_w0x0=leap_wbxb_p25;
    leap_w0x1=leap_wbxa_p25;
    leap_w1x0=leap_waxb_P25;

    pred_diff=leap_w1x1-leap_w0x0;
    resid=pred_diff-actual_diff;
    relerr=resid/actual_diff;

    coeff_diff1=leap_w1x0-leap_w0x0;
    covar_diff1=leap_w1x1-leap_w1x0;
    coeff_diff2=leap_w1x1-leap_w0x1;
    covar_diff2=leap_w0x1-leap_w0x0;

    coeff_share1=coeff_diff1/pred_diff;
    covar_share1=covar_diff1/pred_diff;
    coeff_share2=coeff_diff2/pred_diff;
    covar_share2=covar_diff2/pred_diff;
    output;


    *** p50 ***;
    quantile=0.50;
    actual1=lea_P50;
    actual0=leb_P50;
    actual_diff=lea_P50-leb_P50;

    leap_w1x1=leap_waxa_p50;
    leap_w0x0=leap_wbxb_p50;
    leap_w0x1=leap_wbxa_p50;
    leap_w1x0=leap_waxb_P50;

    pred_diff=leap_w1x1-leap_w0x0;
    resid=pred_diff-actual_diff;
    relerr=resid/actual_diff;

    coeff_diff1=leap_w1x0-leap_w0x0;
    covar_diff1=leap_w1x1-leap_w1x0;
    coeff_diff2=leap_w1x1-leap_w0x1;
    covar_diff2=leap_w0x1-leap_w0x0;

    coeff_share1=coeff_diff1/pred_diff;
    covar_share1=covar_diff1/pred_diff;
    coeff_share2=coeff_diff2/pred_diff;
    covar_share2=covar_diff2/pred_diff;
    output;


    *** p75 ***;
    quantile=0.75;
    actual1=lea_P75;
    actual0=leb_P75;
    actual_diff=lea_P75-leb_P75;

    leap_w1x1=leap_waxa_p75;
    leap_w0x0=leap_wbxb_p75;
    leap_w0x1=leap_wbxa_p75;
    leap_w1x0=leap_waxb_P75;

    pred_diff=leap_w1x1-leap_w0x0;
    resid=pred_diff-actual_diff;
    relerr=resid/actual_diff;

    coeff_diff1=leap_w1x0-leap_w0x0;
    covar_diff1=leap_w1x1-leap_w1x0;
    coeff_diff2=leap_w1x1-leap_w0x1;
    covar_diff2=leap_w0x1-leap_w0x0;

    coeff_share1=coeff_diff1/pred_diff;
    covar_share1=covar_diff1/pred_diff;
    coeff_share2=coeff_diff2/pred_diff;
    covar_share2=covar_diff2/pred_diff;
    output;


    *** p90 ***;
    quantile=0.90;
    actual1=lea_P90;
    actual0=leb_P90;
    actual_diff=lea_P90-leb_P90;

    leap_w1x1=leap_waxa_p90;
    leap_w0x0=leap_wbxb_p90;
    leap_w0x1=leap_wbxa_p90;
    leap_w1x0=leap_waxb_P90;

    pred_diff=leap_w1x1-leap_w0x0;
    resid=pred_diff-actual_diff;
    relerr=resid/actual_diff;

    coeff_diff1=leap_w1x0-leap_w0x0;
    covar_diff1=leap_w1x1-leap_w1x0;
    coeff_diff2=leap_w1x1-leap_w0x1;
    covar_diff2=leap_w0x1-leap_w0x0;

    coeff_share1=coeff_diff1/pred_diff;
    covar_share1=covar_diff1/pred_diff;
    coeff_share2=coeff_diff2/pred_diff;
    covar_share2=covar_diff2/pred_diff;
    output;
run;

proc contents data=dot.decomprun_avg;
proc means data=dot.decomprun_avg;
   class quantile;
run;
proc print data=dot.decomprun_avg;
run;
