*** Test Full Sample Quantile Regression ***;

%include "../../../config.sas";

%let rgroup=%sysget(rgroup);
%let rnum=%sysget(rnum);

%let qt0=0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09;
%let qt1=0.10 0.11 0.12 0.13 0.14 0.15 0.16 0.17 0.18 0.19;
%let qt2=0.20 0.21 0.22 0.23 0.24 0.25 0.26 0.27 0.28 0.29;
%let qt3=0.30 0.31 0.32 0.33 0.34 0.35 0.36 0.37 0.38 0.39;
%let qt4=0.40 0.41 0.42 0.43 0.44 0.45 0.46 0.47 0.48 0.49;
%let qt5=0.50 0.51 0.52 0.53 0.54 0.55 0.56 0.57 0.58 0.59;
%let qt6=0.60 0.61 0.62 0.63 0.64 0.65 0.66 0.67 0.68 0.69;
%let qt7=0.70 0.71 0.72 0.73 0.74 0.75 0.76 0.77 0.78 0.79;
%let qt8=0.80 0.81 0.82 0.83 0.84 0.85 0.86 0.87 0.88 0.89;
%let qt9=0.90 0.91 0.92 0.93 0.94 0.95 0.96 0.97 0.98 0.99;


data temp0(keep=log_earn_all hours hours2 hours3 hours4 partial inactive region ind_dom first_age educ_c);
   set outputs.pik_vars_2(rename=(hours=hours_temp));

   length region 3;

   if st_dom in ("CT", "ME", "MA", "NH", "RI", "VT") then region=1;
   else if st_dom in ("NJ", "NY", "PA") then region=2;
   else if st_dom in ("IL", "IN","MI", "OH", "WI") then region=3;
   else if st_dom in ("IA", "KS", "MN", "MO", "NE", "ND", "SD") then region=4;
   else if st_dom in ("DE", "FL", "GA", "MD", "NC", "SC", "VA", "DC", "WV") then region=5;
   else if st_dom in ("AL", "KY", "MS", "TN") then region=6;
   else if st_dom in ("AR", "LA", "OK", "TX") then region=7;
   else if st_dom in ("AZ", "CO", "ID", "MT", "NV", "NM", "UT", "WY") then region=8;
   else if st_dom in ("AK", "CA", "HI", "OR", "WA") then region=9;

   hours=(hours_temp*12)/(full+partial);

   hours2=(hours**2)/1000;
   hours3=(hours**3)/10000000;
   hours4=(hours**4)/10000000000;

   if pchar="&rgroup" then output;
run;

ods output ParameterEstimates=est1;
proc hpquantselect data=temp0;
  class region ind_dom educ_c;
  model log_earn_all=hours hours2 hours3 hours4 partial inactive region ind_dom first_age educ_c /quantiles=&&qt&rnum;
  performance details nthreads=10;
run;
ods output close;

proc contents data=est1;
proc print data=est1;
run;

proc transpose data=est1 out=dot.qparms_&rgroup._&rnum(drop=_NAME_);
   by Quantile;
   id Parameter;
   var Estimate;
run;

proc contents data=dot.qparms_&rgroup._&rnum;
proc print data=dot.qparms_&rgroup._&rnum;
run;
