*** Pull together the data from all the runs ***;

%include "../../config.sas";

libname rdat 
           ("./0FAN",
            "./0FBN",
            "./0FOA",
            "./0FWH",
            "./0FWN",
            "./0MAN",
            "./0MBN",
            "./0MOA",
            "./0MWH",
            "./0MWN",
            "./1FAN",
            "./1FBN",
            "./1FOA",
            "./1FWH",
            "./1FWN",
            "./1MAN",
            "./1MBN",
            "./1MOA",
            "./1MWH",
            "./1MWN");


%macro loop(pc);
   %let pcl=%sysfunc(lowcase(&pc));
   %do i=0 %to 9;
      data temp1;
         retain pchar;
         set rdat.qparms_&pcl._&i;
         length pchar $4;
         pchar="&pc";
      run;
      proc append base=qparms_all data=temp1;
      run;
   %end;
%mend;

%loop(0FAN);
%loop(0FBN);
%loop(0FOA);
%loop(0FWH);
%loop(0FWN);
%loop(0MAN);
%loop(0MBN);
%loop(0MOA);
%loop(0MWH);
%loop(0MWN);
%loop(1FAN);
%loop(1FBN);
%loop(1FOA);
%loop(1FWH);
%loop(1FWN);
%loop(1MAN);
%loop(1MBN);
%loop(1MOA);
%loop(1MWH);
%loop(1MWN);

proc sort data=qparms_all out=dot.qparms_all;
  by pchar quantile;
run;

proc contents data=dot.qparms_all;
proc print data=dot.qparms_all;
run;
