#!/bin/bash

#### Config Parameters ####
# Number of CPUs
cp=7
# GB of Memory
mm=X
# Bash Script Name
bn=run
# PCHAR
rg=XXXX
###########################

cs=$(expr ${cp} - 1)
ms=$(expr ${mm} - 1)

date > jid.log
echo "#!/bin/bash" > stop.bash

for i in {0..9}
do
   rn=${i}
   rm -f ${bn}_${rn}.*
   if [ -f 01_qrdecomp.sas ];
      then
         cp 01_qrdecomp.sas ${bn}_${rn}.sas
      else
         cp ../01_qrdecomp.sas ${bn}_${rn}.sas
   fi
   echo '#!/bin/bash' > ${bn}_${rn}.bash
   echo '##############################################################' >> ${bn}_${rn}.bash
   echo '# PBS resource request MUST match resources used below' >> ${bn}_${rn}.bash
   echo "#PBS -l select=1:ncpus=${cp}:mem=${mm}gb" >> ${bn}_${rn}.bash
   echo '# Base Name Used to Create the Log File (bname.pbs_jobid.log)' >> ${bn}_${rn}.bash
   echo "bname=${bn}_${rn}.bash" >> ${bn}_${rn}.bash
   echo '# Resource Monitor Iteration Interval (default is 60 seconds)' >> ${bn}_${rn}.bash
   echo 'iterslp=60' >> ${bn}_${rn}.bash
   echo '##############################################################' >> ${bn}_${rn}.bash
   echo '' >> ${bn}_${rn}.bash
   echo '##############################################################' >> ${bn}_${rn}.bash
   echo '# Source the run_pbs.bash file (required)' >> ${bn}_${rn}.bash
   echo 'iname=/projects/bin/scripts/run_pbs.bash' >> ${bn}_${rn}.bash
   echo 'if [ -n ${iname} ] ; then' >> ${bn}_${rn}.bash
   echo '   source  ${iname}' >> ${bn}_${rn}.bash
   echo 'else' >> ${bn}_${rn}.bash
   echo '   echo "run_pbs.bash not found"' >> ${bn}_${rn}.bash
   echo '   exit' >> ${bn}_${rn}.bash
   echo 'fi' >> ${bn}_${rn}.bash
   echo '##############################################################' >> ${bn}_${rn}.bash
   echo '' >> ${bn}_${rn}.bash
   echo '#######################################################' >> ${bn}_${rn}.bash
   echo '### List runpbs commands below                      ###' >> ${bn}_${rn}.bash
   echo '### Syntax: runpbs <command>                        ###' >> ${bn}_${rn}.bash
   echo '### Example: runpbs sas test_pbs.sas                ###' >> ${bn}_${rn}.bash
   echo '#######################################################' >> ${bn}_${rn}.bash
   echo '' >> ${bn}_${rn}.bash
   echo "export SASV9_OPTIONS='-rsasuser -cpucount=${cs} -memsize ${ms}G -sumsize ${ms}G -sortsize ${ms}G'" >> ${bn}_${rn}.bash
   echo "export rgroup=${rg}" >> ${bn}_${rn}.bash
   echo "export rnum=${rn}" >> ${bn}_${rn}.bash
   echo "runpbs sas ${bn}_${rn}.sas" >> ${bn}_${rn}.bash
   # Submit job
   jid1=$(qsub ${bn}_${rn}.bash)
   echo $jid1
   echo "${bn}_${rn}.bash job id: ${jid1}" >> jid.log
   echo "qdel ${jid1}" >> stop.bash
done
