/* Configuration File */

*** OPTIONS ***;
options mlogic mprint symbolgen fullstimer msglevel=i ps=200 ls=200 nocenter obs=max;

*** Include parameters file for programs 01_ui/05.01, 01_ui/08.01 and 01_ui/09.01 ***;
%include "./parameters.sas";

%let obsv=max;

*** Vintage: snapshot | release date ***;
%let vintage = s2017_2019_12_14;

*** LIBNAMES ***;
libname dot ".";
* Census Numident *;
libname cnum "" access=readonly;
* EHF ICF and ECF *;
libname ui (""
            ""
            "") access=readonly;

libname outputs "";

*** Base Year for Real Earnings ***;
%LET baseyr=2010;

*** States in LEHD ***;
%LET states = ak al ar az ca co ct dc de fl
              ga hi ia id il in ks ky la ma
              md me mi mn mo ms mt nc nd ne
              nh nj nm nv ny oh ok or pa ri
              sc sd tn tx ut va vt wa wi wv
              wy;

*** Start and end dates for qtime ***;
%LET ystart = 1985; *DO NOT ALTER (earliest year quarter of available UI data is 1985q1);
%LET qstart = 1; *DO NOT ALTER (earliest year quarter of available UI data is 1985q1);

%LET yend = 2018; *LAST AVAILABLE YEAR OF DATA ON SNAPSHOT 2015;
%LET qend = 4; *LAST AVAILABLE QUARTER OF DATA ON SNAPSHOT 2015;

*** Analysis Years ***;

%LET begyr = 2004;
%LET endyr = 2015;
%LET nyrs = %eval(&endyr. - &begyr. + 1);  *number of Analysis Years;

%LET begyrd = 2005;
%LET endyrd = 2015;
%LET nyrsd = %eval(&endyrd. - &begyrd. + 1);  *number of Analysis Years (1st differences);

*** Work array ***;
%LET wdim = %eval((&yend. - &ystart. + 1)*4);  *number of quarters from ymin to yend;
%LET wbit = %sysfunc(ceil(&wdim./8)); *number of bytes required for bit format;
        ** divide number of quarters by 8 and round up **;
        ** get number of bytes required for bit format **;

*** Macro to set the Earnings Data ***;
%macro sline(lib=,data=,keepvars=);
   set
   %local i;
   %let i=1;
   %let NN = %scan(&PIK2short.,&i.);
   %do %until ("&NN" = "");
       &lib..&data._&NN.(keep=&keepvars. obs=&obsv.)
       %let i = %eval(&i.+1);
       %let NN = %scan(&PIK2short.,&i.," ");
   %end;;
%mend;
